unit scrsh;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ShellAPI, Jpeg, ComCtrls, Spin, Math,
  FileCtrl, GdipApi, GdipClass, Masks, XPMan;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    Button2: TButton;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    Label8: TLabel;
    ProgressBar1: TProgressBar;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Button3: TButton;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label5: TLabel;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label3: TLabel;
    ListView1: TListView;
    OpenDialog1: TOpenDialog;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    CheckBox2: TCheckBox;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    CheckBox3: TCheckBox;
    CheckBox1: TCheckBox;
    SpeedButton6: TSpeedButton;
    procedure CheckBox1Click(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
 public
    procedure Recheck_Sizes;
    procedure Photo_Needed;
 end;

var
 Form1: TForm1;
 temp_bmp: TBitmap;
 imgch: boolean;
 bmw,bmh: integer;
 path: string;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 //   
 Image1.Parent.DoubleBuffered:=true;
 //
 if Image1.Picture.Graphic is TJPEGImage
 then TJPEGImage(Image1.Picture.Graphic).DIBNeeded;

 Image1.AutoSize:=false;
 Image1.Width:=ScrollBox1.Width-4;
 Image1.Height:=ScrollBox1.Height-4;
 Image1.Stretch:=true;

 temp_bmp:=TBitmap.Create;

 path:=ExtractFilePath(ParamStr(0));
 OpenDialog1.InitialDir:=path;

 Image1.Hint:='Double click to view the generated image';

 Label4.Caption:=Format('Preview (%dx%d):',[SpinEdit3.Value,SpinEdit4.Value]);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if CheckBox1.Checked
 then
  begin
   Image1.AutoSize:=false;
   Image1.Width:=ScrollBox1.Width-4;
   Image1.Height:=ScrollBox1.Height-4;
   Image1.Stretch:=true;
  end
 else
  begin
   Image1.AutoSize:=true;
   Image1.Stretch:=false;
  end;
end;

procedure TForm1.FileListBox1Change(Sender: TObject);
var
 i,j: integer;
begin
 j:=0;
 for i:=0 to ListView1.Items.Count-1 do
  begin
   if ListView1.Items.Item[i].Selected
   then inc(j);
  end;

 Label2.Caption:=Format('Files selected: %d / %d',[ListView1.Items.Count,j]);

 Recheck_Sizes; 
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if ListView1.Items.Count=0 then Exit;

 ListView1.SelectAll;
 Label2.Caption:=Format('Files selected: %d / %d',[ListView1.Items.Count,ListView1.Items.Count]);

 Recheck_Sizes; 
end;

// 450x338 - 50x38
// 450x338 - 550x413 (x418)
procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
 if (imgch=false) and (CheckBox2.Checked)
 then
  begin
{
   if (Image1.Picture<>nil) and (SpinEdit1.Text<>'')
   then
    begin 
     if (SpinEdit2.Value>(bmw div SpinEdit1.Value))
                                 and (bmw>SpinEdit1.Value)
     then
      begin
       SpinEdit2.Value:=Round(SpinEdit2.Value / (bmw / SpinEdit1.Value));  
       bmw:=SpinEdit1.Value;
       bmh:=SpinEdit2.Value;
      end;
    end;
}
{
   if (Image1.Picture<>nil) and (SpinEdit1.Text<>'')
   then
    begin
     if (SpinEdit2.Value>(bmh div SpinEdit1.Value))
                                  and (SpinEdit1.Value>bmw)
     then
      begin
       SpinEdit2.Value:=Round(SpinEdit2.Value * (SpinEdit1.Value / bmw));
       bmw:=SpinEdit1.Value;
       bmh:=SpinEdit2.Value;
      end;
    end;
}
  end;

 imgch:=false;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 Label1.Caption:='Compress: '+IntToStr(TrackBar1.Position)+'%';
end;

procedure TForm1.Recheck_Sizes;
begin
 if (SpinEdit3.Value mod SpinEdit1.Value)<>0
 then SpinEdit3.Value:=Round(SpinEdit3.Value / SpinEdit1.Value)*SpinEdit1.Value;
 if (SpinEdit4.Value mod SpinEdit2.Value)<>0
 then SpinEdit4.Value:=Round(SpinEdit4.Value / SpinEdit2.Value)*SpinEdit2.Value;

 Photo_Needed;
end;

procedure TForm1.Photo_Needed;
var
 i,j: integer;
begin
 i:=SpinEdit3.Value div SpinEdit1.Value;
 j:=SpinEdit4.Value div SpinEdit2.Value;
 i:=i*j;

 Label3.Caption:=Format('Photos needed: %d',[i]);
end;

procedure FindFiles(StartFolder, Mask: string; List: TStrings;
  ScanSubFolders: Boolean = true);
var
 FindResult: integer;
 SearchRec: TSearchRec;
 MaskJ1,MaskJ2,MaskB: string;
begin
 List.BeginUpdate;

 MaskJ1:='*.jpg';
 MaskJ2:='*.jpeg';
 MaskB:='*.bmp';

 try
  StartFolder:=IncludeTrailingBackslash(StartFolder);
  FindResult:=FindFirst(StartFolder+'*.*', faAnyFile, SearchRec);

  try
   while FindResult = 0 do
    with SearchRec do
     begin
      if (Attr and faDirectory)<>0
      then
       begin
        if ScanSubFolders and (Name<>'.') and (Name<>'..')
        then FindFiles(StartFolder+Name, Mask, List, ScanSubFolders);
       end
      else
       begin
        if (MatchesMask(Name, MaskJ1)) or (MatchesMask(Name, MaskJ2))
          or (MatchesMask(Name, MaskB))
        then List.Add(StartFolder+Name);
       end;
      FindResult:=FindNext(SearchRec);
     end;
    finally
     FindClose(SearchRec);
    end;
  finally
   List.EndUpdate;
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
 i: integer;
 s,ss: string;
 nitem: TListItem;
 StrIm: TStringList;
begin
 if OpenDialog1.Execute
 then
  begin
   StrIm:=TStringList.Create;
   StrIm.Text:=OpenDialog1.Files.Text;

   ListView1.Items.BeginUpdate;
   for i:=0 to StrIm.Count-1 do
    begin
     s:=StrIm.Strings[i];

     nitem:=Listview1.Items.Add;
     nitem.Caption:=ExtractFileName(s);
     ss:=ExtractFileExt(s);
     Delete(ss,1,1);
     nitem.SubItems.Add(AnsiUpperCase(ss));
     nitem.SubItems.Add(s);
    end;
   ListView1.Items.EndUpdate;

   StrIm.Free;
  end;

 Label2.Caption:=Format('Files selected: %d / %d',[ListView1.Items.Count,0]);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
 i: integer;
 s,ss: string;
 nitem: TListItem;
 Str: TStringList;
begin
 if SelectDirectory('Directory tree','',path)
 then
  begin
   Str:=TStringList.Create;
   FindFiles(path, '*.*', Str, false);

   Str.BeginUpdate;
   ListView1.Items.BeginUpdate;
   for i:=0 to Str.Count-1 do
    begin
     s:=Str.Strings[i];

     nitem:=Listview1.Items.Add;
     nitem.Caption:=ExtractFileName(s);
     ss:=ExtractFileExt(s);
     Delete(ss,1,1);
     nitem.SubItems.Add(AnsiUpperCase(ss));
     nitem.SubItems.Add(s);
    end;
   ListView1.Items.EndUpdate;
   Str.EndUpdate;

   Str.Free;
  end;

 Label2.Caption:=Format('Files selected: %d / %d',[ListView1.Items.Count,0]);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
var
 i: integer;
begin
 if ListView1.Selected=nil
 then Exit;

 ListView1.Items.BeginUpdate;

 i:=0;
 repeat
   if ListView1.Items.Item[i].Selected
   then ListView1.Items.Delete(i)
   else inc(i);
 until i>ListView1.Items.Count-1;

 ListView1.Items.EndUpdate;

 Label2.Caption:=Format('Files selected: %d / %d',[ListView1.Items.Count,0]);
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
 Listview1.Items.Clear;

 Label2.Caption:=Format('Files selected: %d / %d',[ListView1.Items.Count,0]);
end;

procedure TForm1.ListView1Click(Sender: TObject);
var
 i,j: integer;
 nitem: TListItem;
 graphics: TGPGraphics;
 Image, pThumbnail: TGPImage;
begin
 // if temp_bmp<>nil
 // then temp_bmp:=nil;

 j:=0;
 for i:=0 to ListView1.Items.Count-1 do
  begin
   if ListView1.Items.Item[i].Selected
   then inc(j);
  end;

 if j>0
 then
  begin
   Label2.Caption:=Format('Files selected: %d / %d',[ListView1.Items.Count,j]);

   Recheck_Sizes;
  end; 

 //

 if ListView1.Selected<>nil
 then
  begin
   nitem:=ListView1.Selected;

   graphics:=TGPGraphics.Create(Image1.Canvas.Handle);
   Image:=TGPImage.Create(nitem.SubItems.Strings[1]);

   pThumbnail:=image.GetThumbnailImage(Image1.Width, Image1.Height, nil, nil);
   graphics.DrawImage(pThumbnail, 0, 0, pThumbnail.GetWidth, pThumbnail.GetHeight);
   Image1.Invalidate;

   Image.Free;
   pThumbnail.Free;
   graphics.Free;
  end;
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
//var
 //graphics: TGPGraphics;
 //Image, pThumbnail: TGPImage;
begin
{
 temp_bmp.Width:=Image1.Width;
 temp_bmp.Height:=Image1.Height;
 temp_bmp.Canvas.Brush.Color:=RGB(255,255,255);
 temp_bmp.Canvas.FillRect(Rect(0,0,temp_bmp.Width,temp_bmp.Height));
 Image1.Picture.Bitmap.Assign(temp_bmp);
}
{
 graphics:=TGPGraphics.Create(Image1.Canvas.Handle);
 Image:=TGPImage.Create(ListBox1.Items.Strings[0]);

 pThumbnail:=image.GetThumbnailImage(Image1.Width, Image1.Height, nil, nil);
 graphics.DrawImage(pThumbnail, 0, 0, pThumbnail.GetWidth, pThumbnail.GetHeight);
 Image1.Invalidate;

 Image.Free;
 pThumbnail.Free;
 graphics.Free;
}
{
 jpg:=TJpegImage.Create;
 jpg.LoadFromFile(FileListbox1.FileName);
 temp_bmp.Assign(Image1.Picture.Bitmap);
 jpg.Free;

 SpinEdit1.Value:=temp_bmp.Width;
 SpinEdit2.Value:=temp_bmp.Height;
}
 imgch:=true;
{
 if Image1.Picture.Graphic<>nil
 then
  begin
   SpinEdit1.Value:=Image1.Picture.Width;
   SpinEdit2.Value:=Image1.Picture.Height;

   bmw:=Image1.Picture.Width;
   bmh:=Image1.Picture.Height;
  end;
}
end;

procedure TForm1.Button3Click(Sender: TObject);
var
 // s: string;
 jpg: TJpegImage;
 Str,Str2: TStringList;
 bmp,bmpjp: TBitmap;
 graphics: TGPGraphics;
 i,k,allf,nx,ny: integer;
 Image, pThumbnail: TGPImage;
begin
 // if not DirectoryExists(ExtractFilePath(Application.ExeName)+'\result')
 // then CreateDir(ExtractFilePath(Application.ExeName)+'\result');
 //
 Label8.Caption:='Processed files: 0 of 0';
 //
 bmpjp:=TBitmap.Create;
 bmp:=TBitmap.Create;
 jpg:=TJpegImage.Create;
 Str:=TStringList.Create;
 Str2:=TStringList.Create;
 //
 allf:=0;
 for i:=0 to ListView1.Items.Count-1 do
  begin
   if ListView1.Items.Item[i].Selected
   then
    begin
     inc(allf);
     Str.Add(ListView1.Items.Item[i].SubItems.Strings[1]);
    end;
  end;
 // 
 if allf=0
 then
  begin
   MessageDlg('No files selected :(',mtInformation,[mbOK],0);

   jpg.Free;
   bmp.Free;
   bmpjp.Free;
   Str.Free;
   Str2.Free;

   Exit;
  end;
 //
 with ProgressBar1 do
  begin
   Max:=allf;
   Refresh;
   Show;
  end;
 //
 ProgressBar1.Position:=0;

 // Round(12.75) = 13
 // Trunc(12.75) = 12
 // Int(12.75) = 12
 // Frac(12.75) = 0.75
{
 // 60
 SpinEdit3.Value:=304;
 SpinEdit4.Value:=232;
 SpinEdit1.Value:=38;
 SpinEdit2.Value:=29;

 // 6
 SpinEdit3.Value:=128;
 SpinEdit4.Value:=96;
 SpinEdit1.Value:=64;
 SpinEdit2.Value:=32;
}
 Recheck_Sizes;

 bmp.Width:=SpinEdit3.Value;
 bmp.Height:=SpinEdit4.Value;
 bmp.Canvas.FillRect(Rect(0,0,bmp.Width,bmp.Height));
 bmp.Canvas.Pen.Color:=clBlack;
 bmp.Canvas.Pen.Width:=1;
{
 //   
 k:=0;
 for i:=0 to bmp.Width do
  begin
   bmp.Canvas.MoveTo(k,0);
   bmp.Canvas.LineTo(k,bmp.Height);
   k:=k+SpinEdit1.Value;
  end;
 //   
 k:=0;
 for i:=0 to bmp.Height do
  begin
   bmp.Canvas.MoveTo(0,k);
   bmp.Canvas.LineTo(bmp.Width,k);
   k:=k+SpinEdit2.Value;
  end;
}
 nx:=0;
 ny:=0;
 SpeedButton1.Enabled:=false;
 Button2.Enabled:=false;
 Button3.Enabled:=false;
 SpeedButton3.Enabled:=false;
 SpeedButton4.Enabled:=false;
 SpeedButton5.Enabled:=false;

 //  
 i:=0;
 while i<=Str.Count-1 do
  begin
   k:=Random(Str.Count);

   if Str2.IndexOf(IntToStr(k))=-1
   then
    begin
     Str2.Add(IntToStr(k));
     inc(i);
    end;
  end;

 k:=0;
 while k<=Str.Count-1 do
  begin
    begin
     try
(*
      s:=FileListBox1.Items.Strings[k];
      jpg.LoadFromFile(FileListBox1.Items.Strings[k]);
      //   (),  
      //     = 0 
      //        jpeg,
      //  ,      
      jpg.DIBNeeded;
      //
      {
      z:=Random(400)+50;
      if jpg.Height>jpg.Width
      then scale:=z/jpg.Height
      else scale:=z/jpg.Width;
      // Create thumbnail bitmap, keep pictures aspect ratio
      bmpjp.Width:=Round(jpg.Width*scale);
      bmpjp.Height:=Round(jpg.Height*scale);
      }
      bmpjp.Width:=SpinEdit1.Value;
      bmpjp.Height:=SpinEdit2.Value;
      bmpjp.Canvas.StretchDraw(bmpjp.Canvas.Cliprect,jpg);
      //
      if (nx+SpinEdit1.Value)>=(bmp.Width)
      then
       begin
        nx:=0;
        ny:=ny+SpinEdit2.Value;
       end
      else
       if (nx<>0) or (k>0)
       then nx:=nx+SpinEdit1.Value;
      bmp.Canvas.Draw(nx,ny,bmpjp);
*)

      bmpjp.Width:=SpinEdit1.Value;
      bmpjp.Height:=SpinEdit2.Value;

      graphics:=TGPGraphics.Create(bmpjp.Canvas.Handle);

      if CheckBox3.Checked
      then Image:=TGPImage.Create(Str.Strings[StrToInt(Str2.Strings[k])])
      else Image:=TGPImage.Create(Str.Strings[k]);

      pThumbnail:=image.GetThumbnailImage(bmpjp.Width, bmpjp.Height, nil, nil);
      graphics.DrawImage(pThumbnail, 0, 0, pThumbnail.GetWidth, pThumbnail.GetHeight);
      Image1.Invalidate;

      Image.Free;
      pThumbnail.Free;
      graphics.Free;

      if (nx+SpinEdit1.Value)>=(bmp.Width)
      then
       begin
        nx:=0;
        ny:=ny+SpinEdit2.Value;
       end
      else
       if (nx<>0) or (k>0)
       then nx:=nx+SpinEdit1.Value;
      bmp.Canvas.Draw(nx,ny,bmpjp);

      inc(k);
      ProgressBar1.Position:=ProgressBar1.Position+1;
     except

     end;

     Label8.Caption:=Format('Processed files: %d of %d',[ProgressBar1.Position,allf]);
    end;
    
   Application.ProcessMessages;
   Sleep(1);
  end;

 Image1.Picture.Bitmap.Assign(bmp);
{
 jpg.Assign(bmp);
 jpg.CompressionQuality:=TrackBar1.Position;
 jpg.Grayscale:=false;
 jpg.Compress;
 jpg.SaveToFile(ExtractFilePath(Application.ExeName)+'gallery.jpg');
}
 jpg.Free;
 bmp.Free;
 bmpjp.Free;
 Str.Free;
 Str2.Free;

 SpeedButton1.Enabled:=true;
 Button2.Enabled:=true;
 Button3.Enabled:=true;
 SpeedButton3.Enabled:=true;
 SpeedButton4.Enabled:=true;
 SpeedButton5.Enabled:=true;
 ProgressBar1.Position:=0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 temp_bmp.Free;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
 ShellExecute(0,'open',PChar(ExtractFilePath(ParamStr(0))+'gallery.jpg'),'','',SW_SHOW);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
 ShowMessage('---------------  Photo Wall v0.75  ---------------'+#10#13+
             ' '+#10#13+
             '            created by Simagin Andrey'+#10#13+
             ''+#10#13+
             '    Copyright  2005-2010 Delphi Sources'+#10#13+
             ''+#10#13+
             ''+#10#13+
             '           Web: www.delphisources.ru'+#10#13+
             ''+#10#13+
             '                           Enjoy ;)');
 // ShellExecute(0,'open','http://www.delphisources.ru','','',SW_SHOW);
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
var
 jpg: TJpegImage;
begin
 if Image1.Picture.Bitmap.Empty=true
 then Exit;

 jpg:=TJpegImage.Create;

 jpg.Assign(Image1.Picture.Bitmap);
 jpg.CompressionQuality:=TrackBar1.Position;
 jpg.Grayscale:=false;
 jpg.Compress;
 jpg.SaveToFile(ExtractFilePath(Application.ExeName)+'gallery.jpg');

 jpg.Free;
end;

procedure TForm1.SpinEdit3Change(Sender: TObject);
begin
 Label4.Caption:=Format('Preview (%dx%d):',[SpinEdit3.Value,SpinEdit4.Value]);
end;

procedure TForm1.SpinEdit4Change(Sender: TObject);
begin
 Label4.Caption:=Format('Preview (%dx%d):',[SpinEdit3.Value,SpinEdit4.Value]);
end;

initialization
 randomize;

end.
